#include <string.h>
#include <math.h>
#include <uf.h>
#include <uf_defs.h>
#include <uf_obj.h>
#include <uf_assem.h>
#include <uf_object_types.h>
#include <uf_modl.h>
#include "calcproto.h"

/**********************************************************************
* calc_comp_array 
*  This routine makes the rectangular array of components by setting
*  up the structure for a master component instance array.
*
* input 
*    button_inst The button component instance tag.
*
* output 
*    calc_comp_array    0 = success, else failure 
*
*   revisions 
*   rv     date    who     reason for change 
*   00   01JUL96   J_P                   
*   01   01AUG97   J_P     Added a call to free the face list
*   02   01JUN98   J_P     Initialized some variables
*   03   14FEB03   DKF     Removed unreferenced variables,
*                          Updated error checking
*  
**********************************************************************/

      int calc_comp_array( tag_t button_inst )
{
/******************** Routine variable declaration  *******************/
    int i,          /* Loop variable */
        count=0;    /* Count of faces. */

    tag_t
        body,       /* Tag of the TOP_HALF body. */
        button_body,/* Tag of the original BUTTON body. */
        array,      /* Tag of the component instance array */
        *occ=NULL;  /* Ptr to occurrence tag of the face */

    uf_list_p_t
        list=NULL;  /* Face list from body. */

    char
        inst_array_name[MAX_ENTITY_NAME_SIZE+1];

    UF_ASSEM_mc_array_data_t
        linear_mc;  /* Master component structure. */

/******************** Beginning of Executable code *********************/
/*XXX get the tag of the original BUTTON body */


/* Initialize the structure to create the component array of Buttons.
 * It will be a master component linear instance array using the same
 * expressions (Up, Across, etc.) used to create the hole instances.
 */

    linear_mc.array_subtype = UF_ASSEM_linear_array;
    linear_mc.master_component = NULL_TAG;
    linear_mc.template_component = button_inst;
    strcpy( inst_array_name, "BUTTON_ARRAY");
    linear_mc.array_name = inst_array_name;

/*XXX Set the linear_mc.dimensions[0..1] values to the tags of the
 * Across and Up expressions.
 */

/*XXX Set the linear_mc.offsets[0..1] values to the tags of expressions
 * Button_width+Button_spacing  and  Button_height+Button_spacing
 */


/*XXX Get the body with the name "TOP_HALF". XXX Get a list of the
 * faces. XXX Get the list count.  The face normals will be checked
 * for normals in the global X and global Y (to define the direction
 * of the component array).
 */

    body = NULL_TAG;

    for( i=0; i<count; i++ ) {
        tag_t face;
        int type, norm_dir;
        double point[3], nrm[3], box[6], radius, rad_data;

/*XXX Obtain the face from the list */

/*XXX Obtain the face data for the normal information */
        if( type != UF_bounded_plane_subtype )
            continue;

        if(fabs(nrm[0] - 1.0) < 0.00001)
            linear_mc.axis_definitions[0] = face;
        if(fabs(nrm[1] - 1.0) < 0.00001)
            linear_mc.axis_definitions[1] = face;
    }

/*XXX Free the list of faces.  Check return code.  */

/*XXX  Create the master component array.  Check return codes.  */

/*XXX  Rename the original "BUTTON" body to "BUTTONONE" for later use */


    return (0);
}

