#include <string.h>
#include <uf_defs.h>
#include <uf_layout.h>
#include <uf_draw.h>
#include <uf_obj.h>
#include <uf_part.h>
#include <uf_view.h>
#include "calcproto.h"

/**********************************************************************
*
* calc_drawing 
*
* Controls the creation of an A2 size drawing of the calculator.  This
* routine creates the drawing, imports a border, and calls the routine
* that adds the views.
*
* input 
*    dname             drawing name 
*
* output 
*    calc_drawing      0 = success, else failure 
*
*  revisions 
*    RV   Date      Who   Reason for Change 
*    00   01NOV95   J_P                   
*    01   01JUL96   J_P   Replaced uc5028 with UF_OBJ_cycle_by_name
*    02   01JUN98   J_P   Added comment re. UF_DRAW_ask_current_drawing
*    03   14FEB03   DKF   Updated method for cycling drawing views
*                         Updated error checking,
*                         Added Windows path
*  
**********************************************************************/

    int calc_drawing( char *dname)
{
/******************** Routine variable declaration  *******************/

    char
        pfile[132],     /* part file name */
        curlay[30],     /* current layout */
        curview[30];    /* current view */

    int dsize,          /* drawing size */
        num_views,      /* output from UF_DRAW_ask_views */
        inx = 0,        /* loop counter for drawing view update */
        flag;           /* success flag */

    const int
        one=1, two=2;

    tag_t 
        drawing_tag,    /* tag for the drawing view. */
		view_tag,       /* tag for current view while updating */
        grp;            /* Dummy object for import */

    double
        amat[6],        /* matrix for part import */
        aorg[3],        /* origin for part import */
        ascale=1.0,     /* Import part scale */
        htwd[2],        /* dummies for custom drawing size */
		fraction=1.0,   /* fit per cent for UF_VIEW_fit_view */
        rdum=0;         /* unused */

    tag_p_t  
        view_list;      /* list is output by UF_DRAW_ask_views */


    UF_import_part_modes_t 
        pmod;           /* Part import structure */

/******************** Beginning of Executable code *********************/

/*  Set up identity matrix for part import.  */
    amat[0] = 1.0; amat[1] = 0.0; amat[2] = 0.0;
    amat[3] = 0.0; amat[4] = 1.0; amat[5] = 0.0;

    aorg[0] = 0.0; aorg[1] = 0.0; aorg[2] = 0.0;

/* Set the drawing size flag for A2 (420 x 594) drawing */
    dsize = 3;

/*XXX Get the name of the current layout.  */

/*XXX Create a drawing using the input argument name.  Trap return code. */
	flag = 
	/* XXX Restore the old layout and return if an error occurred. */
    if( flag ) {
	
	}

/* Initialize the structure for part import.  */
    pmod.layer_mode = IP_WORK;
    pmod.group_mode = IP_NOGROUP;
    pmod.plist_mode = IP_NONE;
    pmod.view_mode = IP_NO_VIEW;
    pmod.cam_mode = FALSE;

/*XXX Retrieve (import) title block part.  Trap the return code. */
	/* Windows */
    strcpy(pfile,".\\files\\dwg-a2border.prt");
	/* Unix 
    strcpy(pfile,"./files/dwg-a2border.prt");*/
	flag = 
	/* XXX Restore the old layout and return if an error occurred. */
    if( flag ) {
	
	}

/* Place the views onto the drawing.  */
    flag = calc_drawing_views(dname,dsize);
    if( flag ) return( flag );

/* Obtain the drawing tag. */
    UF_CALL( UF_DRAW_ask_current_drawing (&drawing_tag) );

/* Cycle through the views and update each view. */
    UF_CALL( UF_DRAW_ask_views( drawing_tag, &num_views, &view_list ));
    for( inx = 0; inx < num_views; inx++ )    {
    /*XXX Get the tag of that view */
		
	/*XXX update the view on the drawing */

    }
        
    if( view_list != NULL ) UF_free( view_list );

    return (0);
}
