/************************************************************************
*   calc_part
*
* This routine checks for open parts.  If parts are open, it allows the
* user to save and close or close the opened parts.  The program will try
* to open the calculator part  (calculator.prt).
*
*  input
*    (none)
*
*  output
*    calc_part     0 = success, else failure
*  revisions
*    rv    date        who    reason for change
*    00    01NOV95     J_P   
*    01    14FEB03     DKF    Update error checking, add Windows path
*
************************************************************************/


#include <string.h>
#include <uf_defs.h>
#include <uf.h>
#include <uf_part.h>
#include <uf_ui.h>
#include "calcproto.h"

    int calc_part()
{
/********************* Routine variable declaration  ********************/

    char
        estr[132];          /* general purpose string */

    int numparts,            /* number of currently loaded parts */
        resp;                /* user response */

    tag_t
        parent;              /* tag of parent part */

    UF_PART_load_status_t
        estat;               /* structure for load part */

/******************** Beginning of Executable code **********************/
 

/*XXX Determine if any parts are open (check num_parts) */

    if(numparts > 0)
    {  
        char
            option[2][38];      /* menu options */

        int deflt,               /* menu default */
            errcount,            /* count of errors from
                                    UF_PART_save_all */
            *errcodes;           /* error codes from UF_PART_save_all */

        tag_t
            *errtags;            /* tags of parts that failed to save */

        /*XXX Put up 2 options;  "Save and close" or "close without
         * saving".  Use the 'Close' option as the default.
         */
        strcpy( option[0], "Save and Close all parts" );
        strcpy( option[1], "Close all parts w/o save" );
        deflt = 2;

/* Dismiss the DA2 in preparation for the styler call. */
        UF_CALL( UF_UI_dismiss_dialog_area_2() );

/* Return a 1 if Back or Cancel was picked, or perform selected
 * option.
 */
        if( resp < 3 )
            return( 1 );

/* Check the resp and perform the appropriate action based on the
 * value.  The opened parts will always be closed by going through
 * this section of code. XXX Call the part save all function if
 * the save option was selected.  Check for errors on the save and
 * call the free routines if errors occurred.  XXX Call the part
 * close all function regardless for both cases.  
 */
    }

/*XXX Retrieve calculator.prt using resp = UF_PART_open.  Display an
 * error dialog and return an non-zero if an error occurs.
 */
	/* Windows 
    strcpy( estr, ".\\calculator.prt"); */
	/* Unix */
    strcpy( estr, "./calculator.prt");

    return (0);
}
