/*===========================================================================
 
                  Copyright (c) 1997 Electronic Data Systems Corporation
                             Unpublished - All rights reserved
 
 ===========================================================================*/
#include <string.h>
#include <uf_defs.h>
#include <uf.h>
#include <uf_part.h>

/******************************************************************************/
/*    Protoype internal routines.  Make then static, if possible.             */
   
extern void get_filename( char *, char * );
extern int openprt( char * );

/******************************************************************************/

/******************************************************************************
*  This routine returns a flag; 0 if a display part exists and nonzero if there
*  is no dispaly part.  The routine checks for a display part and, if one does
*  not exist, opens a Motif file selection dialog.  The file from that routine
*  is passed to the openprt routine.  If CANCEL is selected from Motif, a -1 is
*  returned (and openprt is not called).  openprt passes its return code back
*  to the caller. For an assembly, only the root part return code is passed
*  back.  If any components failed to open (but root part did open) then '0'
*  (success) will be returned).
******************************************************************************/
extern int check_display_part( )
{
/************************ Routine variable declaration  ***********************/
    tag_t
        displ_part;        /* Tag of display part;  NULL_TAG if none. */

/************************ Begining of Executable code *************************/


    displ_part = UF_PART_ask_display_part();
    if( NULL_TAG == displ_part  ) {
        char    filename[MAX_FSPEC_SIZE + 1];

/* Obtain the filename of a part to open.  Use *.prt as the filter string */
        get_filename( "*.prt", filename );

/*  strcmp returns TRUE if the arguments do not match.  If the filename is not
 *  CANCEL (ie. strcmp returns TRUE), then try opening the part.
 */
        if( strcmp( filename, "CANCEL" ) )
            return( openprt( filename ) );
        else
            return( -1 );    /* User picked CANCEL */
    }

    return( 0 );
}
