#include <stdio.h>
#include <string.h>
#include <uf.h>
#include <uf_ui.h>
#include <uf_obj.h>

#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))

static int report_error( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char err[133],
             msg[133];

        sprintf(msg, "*** ERROR code %d at line %d in %s:\n+++ ",
            irc, line, file);
        UF_get_fail_message(irc, err);

    /*  NOTE:  UF_print_syslog was new in V18 */

        UF_print_syslog(msg, FALSE);
        UF_print_syslog(err, FALSE);
        UF_print_syslog("\n", FALSE);
        UF_print_syslog(call, FALSE);
        UF_print_syslog(";\n", FALSE);

        if (!UF_UI_open_listing_window())
        {
            UF_UI_write_listing_window(msg);
            UF_UI_write_listing_window(err);
            UF_UI_write_listing_window("\n");
            UF_UI_write_listing_window(call);
            UF_UI_write_listing_window(";\n");
        }
    }

    return(irc);
}

/**********************************************************************
*
* show_tags
*
* select objects, report the tag, type, and subtype 
*
* revisions
*   rv   date      who reason for change
*   00   14FEB03   DMB  
*
* input
*    (none) 
*
* output
*                      0 = success, >0 = error
*  
*  
**********************************************************************/

static tag_t select_an_object(char *prompt)
{
    double
        cp[3];
    int
        resp;
    tag_t
        object,
        view;
	/* Select an object, using UF_UI_select_with_single_dialog */
    UF_CALL(UF_UI_select_with_single_dialog("Select an object", prompt,
        UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY, NULL,NULL,&resp, &object, cp, &view));

    if (resp == UF_UI_OBJECT_SELECTED || resp == UF_UI_OBJECT_SELECTED_BY_NAME)
    {
        UF_CALL(UF_DISP_set_highlight(object, FALSE));
        return object;
    }
    else return NULL_TAG;

}


static void do_it(void)
{
    int
        subtype,
        type;
    tag_t
        object;
    char
        msg[MAX_LINE_SIZE+1];
        
    while ((object = select_an_object("Select an Object")) != NULL_TAG)
    {
        if (!UF_UI_open_listing_window())
        {
            /* Find the tag, type and subtype of the selected object */

            sprintf(msg, "Tag = %d \t Type = %d \t Subtype =  %d\n", 
                object, type, subtype);
            /* Write the result to the listing window */

        }
    }
}

/*ARGSUSED*/
void ufusr(char *param, int *retcode, int paramLen)
{
    if (UF_CALL(UF_initialize())) return;
    do_it();
    UF_terminate();
}

int ufusr_ask_unload(void)
{
    return (UF_UNLOAD_IMMEDIATELY);
}
