#include <stdio.h>
#include <uf_ui.h>
#include <uf_defs.h>
#include <uf_view.h>
#include <uf_csys.h>
#include "calcproto.h"

/**********************************************************************
*
* ug_set_wcs_to_view 
*
*  Sets the WCS to the input view name.  X is horizontal, Y is vertical
*  and Z is perpendicular to the view.  The WCS is located at the view
*  center.
*
* input 
*    vname     View name 
*
* output 
*    ug_set_wcs_to_view      0 = success, !=0, error 
*
* revisions 
*   rv   date      who   reason for change 
*   00   01NOV95   J_P                   
*   01   01JUL96   J_P   Changed to V11 matrix and csys creation fcns.
*   02   01SEP97   J_P   Using the temporary csys functions for the WCS
*   03   14FEB03   DKF   Updated error checking
*  
*  
**********************************************************************/

    int ug_set_wcs_to_view(char *vname)
{
/******************** Routine variable declaration  *******************/

    tag_t
        mat,        /* Matrix object */
        csys;       /* CSYS to set WCS to */

    double
        center[3],  /* view center */
        scale,      /* view scale */
        matrix[9];  /* view orientation */

/******************** Beginning of Executable code *********************/

/*XXX Obtain the view center and XXX matrix for the view (2 separate
 * calls).  Check return codes.
 */


/*XXX Create a matrix object using the view matrix for the orientation.
 *XXX Create a temporary csys object using the matrix object and view
 * center as the origin.
 */

/*XXX Set the WCS pointer to the new coordinate system.  */

    return (0);
}
