#include <stdio.h>
#include <uf_defs.h>
#include <uf_ui.h>
#include <uf_plot.h>
#include "calcproto.h"

/**********************************************************************
*  
* calc_plot 
*
* Plots the input named drawing as an A2 plot on an 8.5 X 11 sheet.
*
* revisions 
*   rv   date      who reason for change 
*   00   01nov95   J_P                   
*   01   01JUN98   J_P Changed some string lengths.
*
* input 
*  dname               name of drawing to plot 
*
* output 
*  calc_plot           0 = success, >0 = error 
*
**********************************************************************/

    int calc_plot(char *dname)
{
/******************** Routine variable declaration  *******************/
    char
        statmsg[132],
        pltr[17]="BOS_ES1", /* Plotter name string.  */
        node[132]="",       /* Plotter node name */
        jobnm[17]="calc",   /* Job name */
        pause[44]="",       /* Pause message */
        banner[132]="";     /* Banner message. */

    int jobid,              /* plot job id */
        flag,               /* Return flag */
        i;                  /* Loop counter */

    UF_PLOT_options_t
        plot_options;       /* Structure controlling plot */

/******************** Beginning of Executable code *********************/

/* Set the plot options.  The scale of .45 allows an A2 to plot on 8.5X11
 * paper.  The rotation will and offset will be zero.  The origin is the
 * lower left corner, 0,0,0.
 */
    plot_options.scale = 0.45;
    plot_options.rotation = 0.0;
    plot_options.origin[0] = 0.0;
    plot_options.origin[1] = 0.0;
    plot_options.origin[2] = 0.0;
    plot_options.offset[0] = 0.0;
    plot_options.offset[1] = 0.0;
    plot_options.plotter = pltr;
    plot_options.node    = node;
    plot_options.jobname = jobnm;
    plot_options.pauseMsg = pause;
    plot_options.bannerMsg  = banner;
    plot_options.bannerFlag = 0;
    plot_options.option = UF_PLOT_PLOT_RELEASE;
    plot_options.media = 1;
    plot_options.copies = 1;
    plot_options.pentype = 1;
    for( i=0; i<16; i++ ) {
        plot_options.pens[i] = 1;
    }

/* Call the plot drawing routine.  Check return code.  */
/*
    flag = UF_PLOT_drawing(dname,&plot_options,&jobid);
*/
    if(flag < 0) return(flag);

    sprintf(statmsg,"Drawing plotted - ID = %d",jobid);
    uc1601(statmsg,0);

    return (0);
}
