#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <uf_assem.h>
#include <uf_defs.h>
#include <uf_ui.h>
#include <uf_obj.h>
#include "calcproto.h"

/**********************************************************************
*
* ug_delete_type 
*
* Deletes all objects of the type passed through the calling argument.
*
* input 
*    etype     the entity type 
*
* output 
*  (none) 
*  
*  
**********************************************************************/

    void ug_delete_type(int etype)
{
/******************** Routine variable declaration  *******************/
    char
        emess[80];  /* error message */

    int ecount,     /* Count of entities of the given type */
        i;          /* loop counter */

    tag_t
        *eids,      /* Array to hold entities */
        part,       /* Tag of the work part. */
        eid;        /* Each entity as it is found */

/******************** Beginning of Executable code *********************/

/* Use the cycle-by-type routine to count the objects of the type. */
    part = UF_ASSEM_ask_work_part();
    ecount = 0;
    eid = NULL_TAG;
    do {
        UF_CALL(UF_OBJ_cycle_objs_in_part(part, etype, &eid) );
        ecount++;
    } while(eid != NULL_TAG);

/* Allocate an array to store the list of tags.  You cannot delete
 * objects in a loop as the cycle routines uses the 'current' object to
 * find the next object in the database.
 */
    eids = (tag_t *) calloc(ecount,sizeof(tag_t));
    if(NULL == eids ) {
        sprintf(emess,"Not enough memory for %d objects",ecount);
        uc1601(emess,1);
        return;
    }

/* Cycle by type again.  This time store the objects to delete.  */
    ecount = 0;
    eid = NULL_TAG;
    do {
        UF_CALL(UF_OBJ_cycle_objs_in_part(part, etype, &eid) );
        eids[ecount] = eid;
        ecount++;
    } while(eid != NULL_TAG);

/* Loop through and delete all objects on the list.  */
    for(i = 0; i < ecount; i++) {
        UF_CALL( UF_OBJ_delete_object(eids[i]) );
    }

/* Free the array allocated for tags.  */
    free(eids);
}
